Attribute VB_Name = "Declarations"
' Declarations part                                                 Use long if possible to speed-up programm
'
Public Const Ring_Buffer_lenght = 255                               ' Serial Buffer lenght
Public Const Sync = 85                                              ' Synchronisation byte
Public Const Telegrams_Lenght = 9                                   ' Number of characters in valid Telegrams
Public Const Max_Telegrams = 20                                     ' Number of max untreated Telegrams - 1

Public PortNr As Long                                               ' Serial Port number
Public PortParameter As String                                      ' Serial Port Parameter as string
Public Instring As String                                           ' Data in the serial port
Public Input_Pointer As Long                                        ' Serial port inputstring pointer
Public Characters_received As Long                                  ' Number of received characters in input buffer
Public RXD_RingBuffer(Ring_Buffer_lenght) As Byte                   ' Ringbuffer of the datas
Public RXD_RingBuffer_Pointer As Long                               ' Telegrams buffer inputstring pointer
Public Last_RingBuffer_Pointer As Long                              ' Telegrams detection Pointer
Public Chars_in_Buffer As Long                                      ' Numbers of untreated chars in ringbuffer
Public Telegrams(Max_Telegrams + 1) As String                       ' Buffer for untreated string Telegrams
Public Telegrams_Untreated As Long                                  ' Pointer to untreated string Telegrams

Public Type Telegrams_Type '  Sync,DAD,SAD,COM,Db1,Db2,Db3,Db4,CRC  plus internal flags
    DAD As Byte                                                     ' Destination address = who has to receive the telegram
    SAD As Byte                                                     ' Source address  = who has to receive the telegram
    CMD As Byte                                                     ' Command that should be treated by destination
    Db1 As Byte                                                     ' First databyte
    Db2 As Byte                                                     ' Secind databyte
    Db3 As Byte                                                     ' Third databyte
    Db4 As Byte                                                     ' Fourth databyte
    CRC As Byte                                                     ' CRC value of the telegram
    OK As Boolean                                                   ' Telegram has valid CRC
    Mystation As Boolean                                            ' Telegram is for this station
    Treated As Boolean                                              ' Telegram is treated by this station
End Type

Public CRC As Byte                                                  ' CRC value
Public Telegram(Max_Telegrams) As Telegrams_Type                    ' The recognized telegramms
Public Telegram_Untreated As Long                                   ' Pointer to untreated valid Telegrams
Public Mystation As Long                                            ' Number of this station

Public I As Long                                                    ' General loop temporary

Public sDAD As Byte                                                 ' Target Destination address = who has to receive the telegram
Public sSAD As Byte                                                 ' Target Source address  = who has to receive the telegram
Public sCMD As Byte                                                 ' Target Command that should be treated by destination
Public sDb1 As Byte                                                 ' Target First databyte
Public sDb2 As Byte                                                 ' Target Secind databyte
Public sDb3 As Byte                                                 ' Target Third databyte
Public sDb4 As Byte                                                 ' Target Fourth databyte
Public sCRC As Byte                                                 ' Target CRC value of the telegram

Public Surview As Boolean                                           ' Help flag for communication

'
' End Declaration part
